/**
 * @file WhiteBoard
 * @copyright WingArc1st Inc.
 * @version 1.0.0
 * @license This plugin is offered by [MIT license] {@link https://opensource.org/licenses/mit-license.php}
 *          
 */
(function(){
	(function(){function r(e,n,t){function o(i,f){if(!n[i]){if(!e[i]){var c="function"==typeof require&&require;if(!f&&c)return c(i,!0);if(u)return u(i,!0);var a=new Error("Cannot find module '"+i+"'");throw a.code="MODULE_NOT_FOUND",a}var p=n[i]={exports:{}};e[i][0].call(p.exports,function(r){var n=e[i][1][r];return o(n||r)},p,p.exports,r,e,n,t)}return n[i].exports}for(var u="function"==typeof require&&require,i=0;i<t.length;i++)o(t[i]);return o}return r})()({1:[function(require,module,exports){
	(function (global){
	//↓↓↓↓↓ Do not change. ↓↓↓↓↓
	function PluginObject(canvasId)
	{
		this.canvasId = canvasId;

		this.x = 0;
		this.y = 0;
		this.width = 0;
		this.height = 0;

		this.drillDown = null;
		this.drillUp = null;
		this.drillThrough = null;
		this.relation = null;
		this.dataPointAction = null;

		this.invalidateDisplayList = null;
		this.callLater = null;
	}

	PluginObject.prototype = {};
	PluginObject.prototype.constructor = PluginObject;
	module.exports = PluginObject;

	PluginObject.prototype.createChildren = function ()
	{
	}

	PluginObject.prototype.updateDisplayList = function (width, height)
	{
	}

	PluginObject.prototype.setConfig = function (config)
	{
	}

	PluginObject.prototype.setData = function (data, type)
	{
		this.dataList = data.dataArray;
	}

	PluginObject.prototype.onMove = function (x, y)
	{
		this.x = x;
		this.y = y;
	}

	PluginObject.prototype.onResize = function (width, height)
	{
		this.width = width;
		this.height = height;
	}

	PluginObject.prototype.onMouseEvent = function (event)
	{
	}

	PluginObject.prototype.onKeyboardEvent = function (event)
	{
	}

	PluginObject.prototype.destroy = function ()
	{
	}

	if (!global.JSPLUGIN) {
		global.JSPLUGIN = {};
	}
	//↑↑↑↑↑ Do not change. ↑↑↑↑↑
	}).call(this,typeof global !== "undefined" ? global : typeof self !== "undefined" ? self : typeof window !== "undefined" ? window : {})
	},{}],2:[function(require,module,exports){
	(function (global){
	var PluginObject = require('./PluginObject');
	/**help
	 * Please write the help text of this plugin here.
	 */
	//↓↓↓↓↓ Please write your program. ↓↓↓↓↓

	/**
	  * WhiteBoard constructor
	  * @memberof WhiteBoard
	  * @method WhiteBoard
	  * @param {String} canvasId - Canvas ID
	  */
	function WhiteBoard(canvasId)
	{
		PluginObject.call(this, canvasId);

		this.canvas = document.getElementById(canvasId);
		this.context2d = this.canvas.getContext('2d');

		/** line thickness（Default：10）
		 * @type {@Number}
		 */
		this.line_width = 10;
		/** line color（Default：Black）
		 * @type {@String}
		 */
		this.stroke_style = '#000000';

		/** button 01：Coordinate positions of four corners
		 * @type {@Number}
		 */
		var btn01_upperL_x = 0;
		var btn01_upperL_y = 0;
		var btn01_upperR_x = 0;
		var btn01_upperR_y = 0;
		var btn01_lowerL_x = 0;
		var btn01_lowerL_y = 0;
		var btn01_lowerR_x = 0;
		var btn01_lowerR_y = 0;
		/** button 02：Coordinate positions of four corners
		 * @type {@Number}
		 */
		var btn02_upperL_x = 0;
		var btn02_upperL_y = 0;
		var btn02_upperR_x = 0;
		var btn02_upperR_y = 0;
		var btn02_lowerL_x = 0;
		var btn02_lowerL_y = 0;
		var btn02_lowerR_x = 0;
		var btn02_lowerR_y = 0;
		/** button 03：Coordinate positions of four corners
		 * @type {@Number}
		 */
		var btn03_upperL_x = 0;
		var btn03_upperL_y = 0;
		var btn03_upperR_x = 0;
		var btn03_upperR_y = 0;
		var btn03_lowerL_x = 0;
		var btn03_lowerL_y = 0;
		var btn03_lowerR_x = 0;
		var btn03_lowerR_y = 0;
		/** button 04：Coordinate positions of four corners
		 * @type {@Number}
		 */
		var btn04_upperL_x = 0;
		var btn04_upperL_y = 0;
		var btn04_upperR_x = 0;
		var btn04_upperR_y = 0;
		var btn04_lowerL_x = 0;
		var btn04_lowerL_y = 0;
		var btn04_lowerR_x = 0;
		var btn04_lowerR_y = 0;
		//button 01：Configuration Information
		this.config01 = {
			/** Name to be displayed on the button
			 * @type {@String}
			 */
			label: "BOLD",
			/** Font color of the name displayed on the button
			 * @type {@String}
			 */
			label_color: "#ffffff",
			/** Font size of the name displayed on the button
			 * @type {@Number}
			 */
			font_size: 14,
			/** Font type of the name to be displayed on the button
			 * @type {@String}
			 */			
			font_family: "Meiryo, san-serif",
		};
		//button 02：Configuration Information
		this.config02 = {
			/** Name to be displayed on the button
			 * @type {@String}
			 */
			label: "FINE",
			/** Font color of the name displayed on the button
			 * @type {@String}
			 */
			label_color: "#ffffff",
			/** Font size of the name displayed on the button
			 * @type {@Number}
			 */
			font_size: 14,
			/** Font type of the name to be displayed on the button
			 * @type {@String}
			 */			
			font_family: "Meiryo, san-serif",
		};
		//button 03：Configuration Information
		this.config03 = {
			/** Name to be displayed on the button
			 * @type {@String}
			 */
			label: "Black / White / Red",
			/** Font color of the name displayed on the button
			 * @type {@String}
			 */
			label_color: "#ffffff",
			/** Font size of the name displayed on the button
			 * @type {@Number}
			 */
			font_size: 14,
			/** Font type of the name to be displayed on the button
			 * @type {@String}
			 */			
			font_family: "Meiryo, san-serif",
		};
		//button 04：Configuration Information
		this.config04 = {
			/** Name to be displayed on the button
			 * @type {@String}
			 */
			label: "Clear",
			/** Font color of the name displayed on the button
			 * @type {@String}
			 */
			label_color: "#ffffff",
			/** Font size of the name displayed on the button
			 * @type {@Number}
			 */
			font_size: 14,
			/** Font type of the name to be displayed on the button
			 * @type {@String}
			 */			
			font_family: "Meiryo, san-serif",
		};
	}

	//↓↓↓↓↓ Do not change. ↓↓↓↓↓
	WhiteBoard.prototype = Object.create(PluginObject.prototype);
	WhiteBoard.prototype.constructor = WhiteBoard;
	module.exports = WhiteBoard;
	//↑↑↑↑↑ Do not change. ↑↑↑↑↑

	/**
	  * Method called by MotionBoard when a plugin item is added
	  * @param none
	  */
	WhiteBoard.prototype.createChildren = function ()
	{
		var preX = 0; //Pointer position
		var preY = 0; //Pointer position
	}

	/**
	 * Methods called by MotionBoard when drawing charts
	 * @param {float}	width	Width of the plugin's drawing area
	 * @param {float}	height	Height of the plugin's drawing area
	 */
	WhiteBoard.prototype.updateDisplayList = function (width, height)
	{
		let ctx = this.context2d;
		const button_width = (width / 2) / 4;
		const button_height = height / 20;
		
		// draw button
		ctx.beginPath();
		ctx.clearRect(0, 0, (width / 2), button_height);

		// get button position（Maintains the coordinates of the four corners of each button）
		this.btn01_upperL_x = 0;
		this.btn01_upperL_y = 0;
		this.btn01_upperR_x = button_width;
		this.btn01_upperR_y = 0;
		this.btn01_lowerL_x = 0;
		this.btn01_lowerL_y = button_height;
		this.btn01_lowerR_x = button_width;
		this.btn01_lowerR_y = button_height;
		this.btn02_upperL_x = this.btn01_upperR_x;
		this.btn02_upperL_y = 0;
		this.btn02_upperR_x = this.btn02_upperL_x + button_width;
		this.btn02_upperR_y = 0;
		this.btn02_lowerL_x = this.btn01_lowerR_x;
		this.btn02_lowerL_y = button_height;
		this.btn02_lowerR_x = this.btn02_lowerL_x + button_width;
		this.btn02_lowerR_y = button_height;
		this.btn03_upperL_x = this.btn02_upperR_x;
		this.btn03_upperL_y = 0;
		this.btn03_upperR_x = this.btn03_upperL_x + button_width;
		this.btn03_upperR_y = 0;
		this.btn03_lowerL_x = this.btn02_lowerR_x;
		this.btn03_lowerL_y = button_height;
		this.btn03_lowerR_x = this.btn03_lowerL_x + button_width;
		this.btn03_lowerR_y = button_height;
		this.btn04_upperL_x = this.btn03_upperR_x;
		this.btn04_upperL_y = 0;
		this.btn04_upperR_x = this.btn04_upperL_x + button_width;
		this.btn04_upperR_y = 0;
		this.btn04_lowerL_x = this.btn03_lowerR_x;
		this.btn04_lowerL_y = button_height;
		this.btn04_lowerR_x = this.btn04_lowerL_x + button_width;
		this.btn04_lowerR_y = button_height;

		// button 01：paint out
		var btn01_fill = ctx.createLinearGradient(this.btn01_upperL_x, this.btn01_upperL_y, this.btn01_lowerR_x, this.btn01_lowerR_y);
		btn01_fill.addColorStop(0, '#004c66');
		btn01_fill.addColorStop(0.5, '#007299');
		btn01_fill.addColorStop(1, '#0099cc');
		ctx.fillStyle = btn01_fill;
		ctx.fillRect(this.btn01_upperL_x, this.btn01_upperL_y, button_width, button_height);
		// button 01：draw a border
		ctx.strokeRect(this.btn01_upperL_x, this.btn01_upperL_y, button_width, button_height);
		// button 01：Set the label
		ctx.font = String(this.config01.font_size) + "px " + this.config01.font_family;
		ctx.fillStyle = this.config01.label_color;
		ctx.fillText(this.config01.label,  (width / 2) * 0.125 - (button_width / 3), button_height / 2);

		// button 02：paint out
		var btn02_fill = ctx.createLinearGradient(this.btn02_upperL_x, this.btn02_upperL_y, this.btn02_lowerR_x, this.btn02_lowerR_y);
		btn02_fill.addColorStop(0, '#004c66');
		btn02_fill.addColorStop(0.5, '#007299');
		btn02_fill.addColorStop(1, '#0099cc');
		ctx.fillStyle = btn02_fill;
		ctx.fillRect(this.btn02_upperL_x, this.btn02_upperL_y, button_width, button_height);
		// button 02：draw a border
		ctx.strokeRect(this.btn02_upperL_x, this.btn02_upperL_y, button_width, button_height);
		// button 02：Set the label
		ctx.font = String(this.config02.font_size) + "px " + this.config02.font_family;
		ctx.fillStyle = this.config02.label_color;
		ctx.fillText(this.config02.label,  (width / 2) * 0.375 - (button_width / 3), button_height / 2);

		// button 03：paint out
		var btn03_fill = ctx.createLinearGradient(this.btn03_upperL_x, this.btn03_upperL_y, this.btn03_lowerR_x, this.btn03_lowerR_y);
		btn03_fill.addColorStop(0, '#004c66');
		btn03_fill.addColorStop(0.5, '#007299');
		btn03_fill.addColorStop(1, '#0099cc');
		ctx.fillStyle = btn03_fill;
		ctx.fillRect(this.btn03_upperL_x, this.btn03_upperL_y, button_width, button_height);
		// button 03：draw a border
		ctx.strokeRect(this.btn03_upperL_x, this.btn03_upperL_y, button_width, button_height);
		// button 03：Set the label
		ctx.font = String(this.config03.font_size) + "px " + this.config03.font_family;
		ctx.fillStyle = this.config03.label_color;
		ctx.fillText(this.config03.label,  (width / 2) * 0.625 - (button_width / 3), button_height / 2);

		// button 04：paint out
		var btn04_fill = ctx.createLinearGradient(this.btn04_upperL_x, this.btn04_upperL_y, this.btn04_lowerR_x, this.btn04_lowerR_y);
		btn04_fill.addColorStop(0, '#004c66');
		btn04_fill.addColorStop(0.5, '#007299');
		btn04_fill.addColorStop(1, '#0099cc');
		ctx.fillStyle = btn04_fill;
		ctx.fillRect(this.btn04_upperL_x, this.btn04_upperL_y, button_width, button_height);
		// button 04：draw a border
		ctx.strokeRect(this.btn04_upperL_x, this.btn04_upperL_y, button_width, button_height);
		// button 04：Set the label
		ctx.font = String(this.config04.font_size) + "px " + this.config04.font_family;
		ctx.fillStyle = this.config04.label_color;
		ctx.fillText(this.config04.label,  (width / 2) * 0.875 - (button_width / 3), button_height / 2);

		ctx.textBaseline = "middle";
		ctx.closePath();

	}

	/**
	  * Methods called by MotionBoard when the mouse button is pressed
	  * @param [PluginMouseEvent] event - Data of mouse events
	  */
	WhiteBoard.prototype.onMouseEvent = function (event)
	{
		var context = this.context2d;
		var flg_mousedown = event.buttonDown;

		//MouseDown
		if (event.type == "mousedown"){
			//Retain coordinates
			this.preX = event.localX;
			this.preY = event.localY;
			//For mouse down in button 01 area（Thick the pen line）
			if (this.preX > this.btn01_lowerL_x && this.preX < this.btn01_lowerR_x) {
				if (this.preY > this.btn01_upperR_y && this.preY < this.btn01_lowerR_y) {
					this.thickenTheLine();
					return;
				}
			}
			//For mouse down in button 02 area（Thin the pen line）
			if (this.preX > this.btn02_lowerL_x && this.preX < this.btn02_lowerR_x) {
				if (this.preY > this.btn02_upperR_y && this.preY < this.btn02_lowerR_y) {
					this.thinTheLine();
					return;
				}
			}
			//For mouse down in button 03 area（Switching color from black to white to red）
			if (this.preX > this.btn03_lowerL_x && this.preX < this.btn03_lowerR_x) {
				if (this.preY > this.btn03_upperR_y && this.preY < this.btn03_lowerR_y) {
					this.whitenTheLine();
					return;
				}
			}
			//For mouse down in button 04 area（Clear）
			if (this.preX > this.btn04_lowerL_x && this.preX < this.btn04_lowerR_x) {
				if (this.preY > this.btn04_upperR_y && this.preY < this.btn04_lowerR_y) {
					context.clearRect(0, 0, this.canvas.width, this.canvas.height);
					this.stroke_style = '#000000';
					return;
				}
			}
			//If outside each button area, draw from the previous coordinate to the current coordinate
			this.drawClickPoint(this.preX, this.preY, event.localX, event.localY);
		}

		//MouseMove
		if (event.type == "mousemove"){
			if (!flg_mousedown){ 
				return;
			}
			//Drawing from the previous clicked coordinate position to the current coordinate position
			this.drawClickPoint(this.preX, this.preY, event.localX, event.localY);
			//Retain coordinates
			this.preX = event.localX;
			this.preY = event.localY;
		}

		//MouseUp
		if (event.type == "mouseup"){
			//As the mouse button is released, false flg_mousedown
			flg_mousedown = false;
		}
		
		//MouseOut
		if (event.type == "mouseout"){
			//Since the mouse cursor has moved out of the canvas, false flg_mousedown
			flg_mousedown = false;
		}
		this.invalidateDisplayList();
	}

	/**
	  * Method to draw a point at the clicked point
	  * @param [float] startX - click start position：X-coordinate
	  * @param [float] startY - click start position：Y-coordinate
	  * @param [float] endX - click end position：X-coordinate
	  * @param [float] endY - click end position：Y-coordinate
	  */
	WhiteBoard.prototype.drawClickPoint = function (startX, startY, endX, endY)
	{
		//Drawing Preparation
		this.context2d.save();
		this.context2d.lineCap = 'round';
		this.context2d.lineWidth = this.line_width;
		this.context2d.strokeStyle = this.stroke_style;

		//Draw a line with coordinates
		this.context2d.beginPath();
		this.context2d.moveTo(startX, startY);
		this.context2d.lineTo(endX, endY);
		this.context2d.stroke();
		this.context2d.restore();
	}

	/**
	  * Method to thicken the line to be drawn by 2 points
	  * @param none
	  */
	WhiteBoard.prototype.thickenTheLine = function ()
	{
		// Max：48
		if (this.line_width < 48) {
			this.line_width = this.line_width + 2;
		}
	}

	/**
	  * Method to thin the line to be drawn by 2 points
	  * @param  none
	  */
	WhiteBoard.prototype.thinTheLine = function ()
	{
		// Minimum：2
		if (this.line_width > 2) {
			this.line_width = this.line_width - 2;
		}
	}

	/**
	  * Method to change the line color to be drawn from black to white to red
	  * @param none
	  */
	WhiteBoard.prototype.whitenTheLine = function ()
	{
		if (this.stroke_style == '#000000') { 
			//White
			this.stroke_style = '#ffffff';
		} else if (this.stroke_style == '#ffffff') {
			//Red
			this.stroke_style = '#ff0000';
		} else {
			//Black
			this.stroke_style = '#000000';
		}
	}

	//↑↑↑↑↑ Please write your program. ↑↑↑↑↑

	global.JSPLUGIN.WhiteBoard = {
		_class_:WhiteBoard
	};

	}).call(this,typeof global !== "undefined" ? global : typeof self !== "undefined" ? self : typeof window !== "undefined" ? window : {})
	},{"./PluginObject":1}]},{},[2]);

}());