/**
 * @file ホワイトボード
 * @copyright WingArc1st Inc.
 * @version 1.0.0
 * @license 本プラグインは[MIT license] {@link https://opensource.org/licenses/mit-license.php}
 *          で提供されます。
 */
(function(){
	(function(){function r(e,n,t){function o(i,f){if(!n[i]){if(!e[i]){var c="function"==typeof require&&require;if(!f&&c)return c(i,!0);if(u)return u(i,!0);var a=new Error("Cannot find module '"+i+"'");throw a.code="MODULE_NOT_FOUND",a}var p=n[i]={exports:{}};e[i][0].call(p.exports,function(r){var n=e[i][1][r];return o(n||r)},p,p.exports,r,e,n,t)}return n[i].exports}for(var u="function"==typeof require&&require,i=0;i<t.length;i++)o(t[i]);return o}return r})()({1:[function(require,module,exports){
	(function (global){
	//↓↓↓↓↓ Do not change. ↓↓↓↓↓
	function PluginObject(canvasId)
	{
		this.canvasId = canvasId;

		this.x = 0;
		this.y = 0;
		this.width = 0;
		this.height = 0;

		this.drillDown = null;
		this.drillUp = null;
		this.drillThrough = null;
		this.relation = null;
		this.dataPointAction = null;

		this.invalidateDisplayList = null;
		this.callLater = null;
	}

	PluginObject.prototype = {};
	PluginObject.prototype.constructor = PluginObject;
	module.exports = PluginObject;

	PluginObject.prototype.createChildren = function ()
	{
	}

	PluginObject.prototype.updateDisplayList = function (width, height)
	{
	}

	PluginObject.prototype.setConfig = function (config)
	{
	}

	PluginObject.prototype.setData = function (data, type)
	{
		this.dataList = data.dataArray;
	}

	PluginObject.prototype.onMove = function (x, y)
	{
		this.x = x;
		this.y = y;
	}

	PluginObject.prototype.onResize = function (width, height)
	{
		this.width = width;
		this.height = height;
	}

	PluginObject.prototype.onMouseEvent = function (event)
	{
	}

	PluginObject.prototype.onKeyboardEvent = function (event)
	{
	}

	PluginObject.prototype.destroy = function ()
	{
	}

	if (!global.JSPLUGIN) {
		global.JSPLUGIN = {};
	}
	//↑↑↑↑↑ Do not change. ↑↑↑↑↑
	}).call(this,typeof global !== "undefined" ? global : typeof self !== "undefined" ? self : typeof window !== "undefined" ? window : {})
	},{}],2:[function(require,module,exports){
	(function (global){
	var PluginObject = require('./PluginObject');
	/**help
	 * Please write the help text of this plugin here.
	 */
	//↓↓↓↓↓ Please write your program. ↓↓↓↓↓

	/**
	  * ホワイトボードコンストラクタ
	  * @memberof WhiteBoard
	  * @method WhiteBoard
	  * @param {String} canvasId - キャンバスID
	  */
	function WhiteBoard(canvasId)
	{
		PluginObject.call(this, canvasId);

		this.canvas = document.getElementById(canvasId);
		this.context2d = this.canvas.getContext('2d');

		/** 線の太さ（デフォルト：10）
		 * @type {@Number}
		 */
		this.line_width = 10;
		/** 線の色（デフォルト：黒色）
		 * @type {@String}
		 */
		this.stroke_style = '#000000';

		/** button 01：四隅の座標位置
		 * @type {@Number}
		 */
		var btn01_upperL_x = 0;
		var btn01_upperL_y = 0;
		var btn01_upperR_x = 0;
		var btn01_upperR_y = 0;
		var btn01_lowerL_x = 0;
		var btn01_lowerL_y = 0;
		var btn01_lowerR_x = 0;
		var btn01_lowerR_y = 0;
		/** button 02：四隅の座標位置
		 * @type {@Number}
		 */
		var btn02_upperL_x = 0;
		var btn02_upperL_y = 0;
		var btn02_upperR_x = 0;
		var btn02_upperR_y = 0;
		var btn02_lowerL_x = 0;
		var btn02_lowerL_y = 0;
		var btn02_lowerR_x = 0;
		var btn02_lowerR_y = 0;
		/** button 03：四隅の座標位置
		 * @type {@Number}
		 */
		var btn03_upperL_x = 0;
		var btn03_upperL_y = 0;
		var btn03_upperR_x = 0;
		var btn03_upperR_y = 0;
		var btn03_lowerL_x = 0;
		var btn03_lowerL_y = 0;
		var btn03_lowerR_x = 0;
		var btn03_lowerR_y = 0;
		/** button 04：四隅の座標位置
		 * @type {@Number}
		 */
		var btn04_upperL_x = 0;
		var btn04_upperL_y = 0;
		var btn04_upperR_x = 0;
		var btn04_upperR_y = 0;
		var btn04_lowerL_x = 0;
		var btn04_lowerL_y = 0;
		var btn04_lowerR_x = 0;
		var btn04_lowerR_y = 0;
		//button 01：設定情報
		this.config01 = {
			/** ボタン上に表示する名前
			 * @type {@String}
			 */
			label: "Thicker",
			/** ボタン上に表示する名前のフォント色
			 * @type {@String}
			 */
			label_color: "#ffffff",
			/** ボタン上に表示する名前のフォントサイズ
			 * @type {@Number}
			 */
			font_size: 14,
			/** ボタン上に表示する名前のフォント種類
			 * @type {@String}
			 */			
			font_family: "Meiryo, san-serif",
		};
		//button 02：設定情報
		this.config02 = {
			/** ボタン上に表示する名前
			 * @type {@String}
			 */
			label: "Thinner",
			/** ボタン上に表示する名前のフォント色
			 * @type {@String}
			 */
			label_color: "#ffffff",
			/** ボタン上に表示する名前のフォントサイズ
			 * @type {@Number}
			 */
			font_size: 14,
			/** ボタン上に表示する名前のフォント種類
			 * @type {@String}
			 */			
			font_family: "Meiryo, san-serif",
		};
		//button 03：設定情報
		this.config03 = {
			/** ボタン上に表示する名前
			 * @type {@String}
			 */
			label: "Black / White / Red",
			/** ボタン上に表示する名前のフォント色
			 * @type {@String}
			 */
			label_color: "#ffffff",
			/** ボタン上に表示する名前のフォントサイズ
			 * @type {@Number}
			 */
			font_size: 14,
			/** ボタン上に表示する名前のフォント種類
			 * @type {@String}
			 */			
			font_family: "Meiryo, san-serif",
		};
		//button 04：設定情報
		this.config04 = {
			/** ボタン上に表示する名前
			 * @type {@String}
			 */
			label: "Clear",
			/** ボタン上に表示する名前のフォント色
			 * @type {@String}
			 */
			label_color: "#ffffff",
			/** ボタン上に表示する名前のフォントサイズ
			 * @type {@Number}
			 */
			font_size: 14,
			/** ボタン上に表示する名前のフォント種類
			 * @type {@String}
			 */			
			font_family: "Meiryo, san-serif",
		};
	}

	//↓↓↓↓↓ Do not change. ↓↓↓↓↓
	WhiteBoard.prototype = Object.create(PluginObject.prototype);
	WhiteBoard.prototype.constructor = WhiteBoard;
	module.exports = WhiteBoard;
	//↑↑↑↑↑ Do not change. ↑↑↑↑↑

	/**
	  * プラグインアイテムが追加された際に、MotionBoardからCallされるメソッド
	  * @param none
	  */
	WhiteBoard.prototype.createChildren = function ()
	{
		var preX = 0; //ポインターの位置
		var preY = 0; //ポインターの位置
	}

	/**
	 * チャートの描画の際にMotionBoardから呼び出されるメソッド
	 * @param {float}	width	プラグインの描画領域の幅
	 * @param {float}	height	プラグインの描画領域の高さ
	 */
	WhiteBoard.prototype.updateDisplayList = function (width, height)
	{
		let ctx = this.context2d;
		const button_width = (width / 2) / 4;
		const button_height = height / 20;
		
		// draw button
		ctx.beginPath();
		ctx.clearRect(0, 0, (width / 2), button_height);

		// get button position（各ボタンの四隅の座標を保持）
		this.btn01_upperL_x = 0;
		this.btn01_upperL_y = 0;
		this.btn01_upperR_x = button_width;
		this.btn01_upperR_y = 0;
		this.btn01_lowerL_x = 0;
		this.btn01_lowerL_y = button_height;
		this.btn01_lowerR_x = button_width;
		this.btn01_lowerR_y = button_height;
		this.btn02_upperL_x = this.btn01_upperR_x;
		this.btn02_upperL_y = 0;
		this.btn02_upperR_x = this.btn02_upperL_x + button_width;
		this.btn02_upperR_y = 0;
		this.btn02_lowerL_x = this.btn01_lowerR_x;
		this.btn02_lowerL_y = button_height;
		this.btn02_lowerR_x = this.btn02_lowerL_x + button_width;
		this.btn02_lowerR_y = button_height;
		this.btn03_upperL_x = this.btn02_upperR_x;
		this.btn03_upperL_y = 0;
		this.btn03_upperR_x = this.btn03_upperL_x + button_width;
		this.btn03_upperR_y = 0;
		this.btn03_lowerL_x = this.btn02_lowerR_x;
		this.btn03_lowerL_y = button_height;
		this.btn03_lowerR_x = this.btn03_lowerL_x + button_width;
		this.btn03_lowerR_y = button_height;
		this.btn04_upperL_x = this.btn03_upperR_x;
		this.btn04_upperL_y = 0;
		this.btn04_upperR_x = this.btn04_upperL_x + button_width;
		this.btn04_upperR_y = 0;
		this.btn04_lowerL_x = this.btn03_lowerR_x;
		this.btn04_lowerL_y = button_height;
		this.btn04_lowerR_x = this.btn04_lowerL_x + button_width;
		this.btn04_lowerR_y = button_height;

		// button 01：塗りつぶす
		var btn01_fill = ctx.createLinearGradient(this.btn01_upperL_x, this.btn01_upperL_y, this.btn01_lowerR_x, this.btn01_lowerR_y);
		btn01_fill.addColorStop(0, '#004c66');
		btn01_fill.addColorStop(0.5, '#007299');
		btn01_fill.addColorStop(1, '#0099cc');
		ctx.fillStyle = btn01_fill;
		ctx.fillRect(this.btn01_upperL_x, this.btn01_upperL_y, button_width, button_height);
		// button 01：枠線を書く
		ctx.strokeRect(this.btn01_upperL_x, this.btn01_upperL_y, button_width, button_height);
		// button 01：ラベルを設定する
		ctx.font = String(this.config01.font_size) + "px " + this.config01.font_family;
		ctx.fillStyle = this.config01.label_color;
		ctx.fillText(this.config01.label,  (width / 2) * 0.125 - (button_width / 3), button_height / 2);

		// button 02：塗りつぶす
		var btn02_fill = ctx.createLinearGradient(this.btn02_upperL_x, this.btn02_upperL_y, this.btn02_lowerR_x, this.btn02_lowerR_y);
		btn02_fill.addColorStop(0, '#004c66');
		btn02_fill.addColorStop(0.5, '#007299');
		btn02_fill.addColorStop(1, '#0099cc');
		ctx.fillStyle = btn02_fill;
		ctx.fillRect(this.btn02_upperL_x, this.btn02_upperL_y, button_width, button_height);
		// button 02：枠線を書く
		ctx.strokeRect(this.btn02_upperL_x, this.btn02_upperL_y, button_width, button_height);
		// button 02：ラベルを設定する
		ctx.font = String(this.config02.font_size) + "px " + this.config02.font_family;
		ctx.fillStyle = this.config02.label_color;
		ctx.fillText(this.config02.label,  (width / 2) * 0.375 - (button_width / 3), button_height / 2);

		// button 03：塗りつぶす
		var btn03_fill = ctx.createLinearGradient(this.btn03_upperL_x, this.btn03_upperL_y, this.btn03_lowerR_x, this.btn03_lowerR_y);
		btn03_fill.addColorStop(0, '#004c66');
		btn03_fill.addColorStop(0.5, '#007299');
		btn03_fill.addColorStop(1, '#0099cc');
		ctx.fillStyle = btn03_fill;
		ctx.fillRect(this.btn03_upperL_x, this.btn03_upperL_y, button_width, button_height);
		// button 03：枠線を書く
		ctx.strokeRect(this.btn03_upperL_x, this.btn03_upperL_y, button_width, button_height);
		// button 03：ラベルを設定する
		ctx.font = String(this.config03.font_size) + "px " + this.config03.font_family;
		ctx.fillStyle = this.config03.label_color;
		ctx.fillText(this.config03.label,  (width / 2) * 0.625 - (button_width / 3), button_height / 2);

		// button 04：塗りつぶす
		var btn04_fill = ctx.createLinearGradient(this.btn04_upperL_x, this.btn04_upperL_y, this.btn04_lowerR_x, this.btn04_lowerR_y);
		btn04_fill.addColorStop(0, '#004c66');
		btn04_fill.addColorStop(0.5, '#007299');
		btn04_fill.addColorStop(1, '#0099cc');
		ctx.fillStyle = btn04_fill;
		ctx.fillRect(this.btn04_upperL_x, this.btn04_upperL_y, button_width, button_height);
		// button 04：枠線を書く
		ctx.strokeRect(this.btn04_upperL_x, this.btn04_upperL_y, button_width, button_height);
		// button 04：ラベルを設定する
		ctx.font = String(this.config04.font_size) + "px " + this.config04.font_family;
		ctx.fillStyle = this.config04.label_color;
		ctx.fillText(this.config04.label,  (width / 2) * 0.875 - (button_width / 3), button_height / 2);

		ctx.textBaseline = "middle";
		ctx.closePath();

	}

	/**
	  * マウスボタンが押された際に、MotionBoardからCallされるメソッド
	  * @param [PluginMouseEvent] event - マウスイベントのデータ
	  */
	WhiteBoard.prototype.onMouseEvent = function (event)
	{
		var context = this.context2d;
		var flg_mousedown = event.buttonDown;

		//MouseDown時
		if (event.type == "mousedown"){
			//座標を保持する
			this.preX = event.localX;
			this.preY = event.localY;
			//ボタン01エリア内のマウスダウンの場合（線を太くする）
			if (this.preX > this.btn01_lowerL_x && this.preX < this.btn01_lowerR_x) {
				if (this.preY > this.btn01_upperR_y && this.preY < this.btn01_lowerR_y) {
					this.thickenTheLine();
					return;
				}
			}
			//ボタン02エリア内のマウスダウンの場合（線を細くする）
			if (this.preX > this.btn02_lowerL_x && this.preX < this.btn02_lowerR_x) {
				if (this.preY > this.btn02_upperR_y && this.preY < this.btn02_lowerR_y) {
					this.thinTheLine();
					return;
				}
			}
			//ボタン03エリア内のマウスダウンの場合（黒→白→赤の切り替え）
			if (this.preX > this.btn03_lowerL_x && this.preX < this.btn03_lowerR_x) {
				if (this.preY > this.btn03_upperR_y && this.preY < this.btn03_lowerR_y) {
					this.whitenTheLine();
					return;
				}
			}
			//ボタン04エリア内のマウスダウンの場合（クリア）
			if (this.preX > this.btn04_lowerL_x && this.preX < this.btn04_lowerR_x) {
				if (this.preY > this.btn04_upperR_y && this.preY < this.btn04_lowerR_y) {
					context.clearRect(0, 0, this.canvas.width, this.canvas.height);
					this.stroke_style = '#000000';
					return;
				}
			}
			//各ボタンエリア外の場合、1つ前の座標から現在の座標まで描画
			this.drawClickPoint(this.preX, this.preY, event.localX, event.localY);
		}

		//MouseMove時
		if (event.type == "mousemove"){
			if (!flg_mousedown){ 
				return;
			}
			//1つ前にクリックした座標位置から現在の座標位置まで描画
			this.drawClickPoint(this.preX, this.preY, event.localX, event.localY);
			//座標を保持する
			this.preX = event.localX;
			this.preY = event.localY;
		}

		//MouseUp時
		if (event.type == "mouseup"){
			//マウスボタンが離されたので、flg_mousedownをfalse
			flg_mousedown = false;
		}
		
		//MouseOut時
		if (event.type == "mouseout"){
			//マウスカーソルがcanvasの外に出たので、flg_mousedownをfalse
			flg_mousedown = false;
		}
		this.invalidateDisplayList();
	}

	/**
	  * クリックされたポイントに点を描画するメソッド
	  * @param [float] startX - クリック開始位置：X座標
	  * @param [float] startY - クリック開始位置：Y座標
	  * @param [float] endX - クリック終了位置：X座標
	  * @param [float] endY - クリック終了位置：Y座標
	  */
	WhiteBoard.prototype.drawClickPoint = function (startX, startY, endX, endY)
	{
		//描画準備
		this.context2d.save();
		this.context2d.lineCap = 'round';
		this.context2d.lineWidth = this.line_width;
		this.context2d.strokeStyle = this.stroke_style;

		//座標を指定して線を引く
		this.context2d.beginPath();
		this.context2d.moveTo(startX, startY);
		this.context2d.lineTo(endX, endY);
		this.context2d.stroke();
		this.context2d.restore();
	}

	/**
	  * 描画する線を2ポイントずつ太くするメソッド
	  * @param none
	  */
	WhiteBoard.prototype.thickenTheLine = function ()
	{
		// 最大値：48
		if (this.line_width < 48) {
			this.line_width = this.line_width + 2;
		}
	}

	/**
	  * 描画する線を2ポイントずつ細くするメソッド
	  * @param  none
	  */
	WhiteBoard.prototype.thinTheLine = function ()
	{
		// 最小値：2
		if (this.line_width > 2) {
			this.line_width = this.line_width - 2;
		}
	}

	/**
	  * 描画する線を黒→白→赤へ変更するメソッド
	  * @param none
	  */
	WhiteBoard.prototype.whitenTheLine = function ()
	{
		if (this.stroke_style == '#000000') { 
			//White
			this.stroke_style = '#ffffff';
		} else if (this.stroke_style == '#ffffff') {
			//Red
			this.stroke_style = '#ff0000';
		} else {
			//Black
			this.stroke_style = '#000000';
		}
	}

	//↑↑↑↑↑ Please write your program. ↑↑↑↑↑

	global.JSPLUGIN.WhiteBoard = {
		_class_:WhiteBoard
	};

	}).call(this,typeof global !== "undefined" ? global : typeof self !== "undefined" ? self : typeof window !== "undefined" ? window : {})
	},{"./PluginObject":1}]},{},[2]);

}());